
##### First load all each whistle into it's own dataframe for futher processing
##Home Drive
#Drive <- "G:/"
##Work Drive
Drive <- "H:/"
#Drive <- "F:/"

###Transmission variables for calculating mean difference between sound
# and light travel
soundDistance <- 1 #mean distance of bird from mic
spSound <- 340.29
spLight <- 229792458
lightDistance <- 8  #mean distance of bird from Cameras
transDelay <- soundDistance/spSound -lightDistance /spLight 
meanCycleDuration <- 0.078
delayPercent <- transDelay/meanCycleDuration 
meanTrough <- 0.043 
percentTrough <- meanTrough / meanCycleDuration 
#
###/Transmission variables

maxTakeOffs <- 20

##Load acoustic element frame and wing-angle information
fullpath <- ""
synchDataR <- list( )
synchDataP <- list( )
synchDataRc <- list( )
synchDataPc <- list( )
for(i in 1:maxTakeOffs ){
	tempData <- NA
	if (i < 10){
		fileNumber <- paste0("0", i)
	}else{
		fileNumber <- i
	}
	tempFilenameR  <-  paste0(Drive, "Crested Pigeon/Image Series/Synchronisation/Synchronicity Output/Routine", fileNumber , ".csv") 
	tempFilenameP  <-  paste0(Drive, "Crested Pigeon/Image Series/Synchronisation/Synchronicity Output/Alarm", fileNumber , ".csv") 
	tempFilenamePc  <-  paste0(Drive, "Crested Pigeon/Image Series/Synchronisation/Synchronicity Output/Alarm", fileNumber , "Clap", ".csv")
	tempFilenameRc  <-  paste0(Drive, "Crested Pigeon/Image Series/Synchronisation/Synchronicity Output/Routine", fileNumber , "Clap", ".csv")
	if (file.exists(tempFilenameR)){
		tempDataR <- read.csv(tempFilenameR )
	} else { tempDataR  <- NA}
	if (file.exists(tempFilenameP)){
		tempDataP <- read.csv(tempFilenameP )
	} else { tempDataP  <- NA}

	if (file.exists(tempFilenameRc)){
		tempDataRc <- read.csv(tempFilenameRc )
	} else { tempDataRc  <- NA}
	if (file.exists(tempFilenamePc)){
		tempDataPc <- read.csv(tempFilenamePc )
	} else { tempDataPc  <- NA}

	synchDataR[[i]] <- cbind.na(tempDataR, tempDataRc)
	synchDataP[[i]] <- cbind.na(tempDataP, tempDataPc)	
}

##Convert to a new column of wing-cycle information

batch.Merge.Wingcycle <- function( wingAngleList, synchData, wingNames){	
	newWingList <- data.frame()
	tempData <-  data.frame()
	wingAnglePair <- data.frame()
	firstFlag <- TRUE
	for(i in 1:maxTakeOffs ){
		if( !is.na(synchData[[i]]) && !is.na(match(i, wingNames))){
			j <- match(i, wingNames)
			wingAnglePair <- cbind(wingAngleList[,j*2-1], wingAngleList[,j*2])
			colnames(wingAnglePair ) <- c(i, 'wing')
			#print(head(wingAnglePair))
			#print(head(synchData[[i]]))
			tempData <- merge.WingCycle(wingAnglePair, synchData[[i]])
			#print(head(tempData ))
			#n <- max(nrow(newWingList), nrow(tempData ))
			#nrow(newWingList) <- n                      
			#nrow(tempData ) <- n
			if( firstFlag ){
				newWingList <- tempData 
				firstFlag <- FALSE
			} else{
				newWingList <- cbind.na(newWingList, tempData )
			}
			
		}
	}
	return(newWingList )
}

## aligns physical wing cycle and acoustic element production 
# by making columns in the wing beat cycle to show when specific elements occur
merge.WingCycle <- function( wingAngleList, synchData){
	badName <- wingAngleList
	lowNote <- vector()
	highNote <- vector()
	clap <- vector()
	toneASubset <- synchData[ grepl( "ToneA", colnames(synchData)) ]
	toneBSubset <- synchData[ grepl( "ToneB", colnames(synchData)) ]
	clapSubset <- synchData[ grepl( "Clap", colnames(synchData)) ]

	for( i in 1:ncol(toneASubset)){
		if( i %% 2 == 1 && ncol(toneASubset) >=1){
			tempIndices <- match(toneASubset[,i], wingAngleList[,1])
			#print(tempIndices)
			lowNote[tempIndices] <- "Low"
			tempIndices <- c()
		}
	}	
	for( i in 1:ncol(toneBSubset)){
		if( i %% 2 == 1 && ncol(toneBSubset) >=1){
			tempIndices <- match(toneBSubset[,i], wingAngleList[,1])
			#print(tempIndices)
			highNote[tempIndices] <- "High"
			tempIndices <- c()
		}
	}
	for( i in 1:ncol(clapSubset )){
		if( i %% 2 == 1 && ncol(clapSubset) >=1 ){
			tempIndices <- match(clapSubset[,i], wingAngleList[,1])
			#print(tempIndices)
			clap[tempIndices] <- "Clap"
			tempIndices <- c()
		}
	}

	#print(head(highNote))
	#print(head(lowNote))
	#n <- max(length(wingAngleList), length(highNote), length(lowNote))
	#length(badName ) <- n                      
	#length(highNote) <- n
	#length(lowNote) <- n
	badName <- cbind.na(badName , highNote, lowNote, clap)
	print(i)
	return(badName )
}
##First Generate high/low columns
wingNotesP <- batch.Merge.Wingcycle(PromptedWA  , synchDataP, PromptedNames )
wingNotesR <- batch.Merge.Wingcycle(RoutineWA  , synchDataR, RoutineNames )

## A single frame error that needs correcting since it produces a peak
AngleR[216, 7] <- 10.2
AngleR[49, 1] <- 102.2
#wingNotesP[246, 35:36] <- NA 
#wingNotesP[214, 31:32] <- NA 
#wingNotesP[307, 27:28] <- NA
#wingNotesP[178, 23:24] <- NA 
#wingNotesP[440, 11:12] <- NA  
#wingNotesP[243, 19:20] <- NA 
#wingNotesP[406, 3:4] <- NA 
#wingNotesP[376, 7:8] <- NA 



###Then Generate Cycle number columns for each take-off
#
for( i in 1:ncol(AngleP)){
	##First set all NA values (0 & NaN) to R's NA
	AngleP[[i]][AngleP[[i]] == 0] <- NA
	AngleP[[i]][AngleP[[i]] == 'NaN'] <- NA
}

for( i in 1:ncol(AngleR)){
	##First set all NA values (0 & NaN) to R's NA
	AngleR[[i]][AngleR[[i]] == 0] <- NA
	AngleR[[i]][AngleR[[i]] == 'NaN'] <- NA
}


### now Generate peaks column
# See getWingCycle.R
peaktroughListP  <- data.frame()
peaktroughListP  <- batch.Get.Peaks( AngleP, PromptedNames, Prompted180, TRUE )
colnames(peaktroughListP  ) <- PromptedNames 
peaktroughListR  <- data.frame()
peaktroughListR  <- batch.Get.Peaks( AngleR, RoutineNames, Routine180, TRUE )
colnames(peaktroughListR  ) <- RoutineNames 
#
###


###Then Generate Cycle number columns for each take-off
#
for( i in 1:ncol(peaktroughListP  )){
	##First set all NA values (0 & NaN) to R's NA
	peaktroughListP  [[i]][peaktroughListP  [[i]] == 0] <- NA
	peaktroughListP  [[i]][peaktroughListP  [[i]] == 'NaN'] <- NA
}

for( i in 1:ncol(peaktroughListR  )){
	##First set all NA values (0 & NaN) to R's NA
	peaktroughListR  [[i]][peaktroughListR  [[i]] == 0] <- NA
	peaktroughListR  [[i]][peaktroughListR  [[i]] == 'NaN'] <- NA
}
cycleListP <- cbind()
for( i in 1:ncol(peaktroughListP)){
	cycleListP <- cbind(cycleListP, getOnlyPeaks(peaktroughListP[,i], Prompted180[i] ))
}
colnames(cycleListP ) <- PromptedNames 

cycleListR <- cbind()
for( i in 1:ncol(peaktroughListR  )){
	cycleListR <- cbind(cycleListR, getOnlyPeaks(peaktroughListR[,i], Routine180[i] ))
}
colnames(cycleListR ) <- RoutineNames
#
###

### And time since last peak Column
#
cycleTimeP <- cbind()
for( i in 1:ncol(cycleListP)){
	tempColumn <- get.Cycle.Time(cycleListP[,i], PromptedFPS[,i] )
	cycleTimeP <- cbind(cycleTimeP, tempColumn )
}
colnames(cycleTimeP ) <- PromptedNames
cycleTimeR <- cbind()
for( i in 1:ncol(cycleListR)){
	tempColumn <- get.Cycle.Time(cycleListR[,i], RoutineFPS[,i] )
	cycleTimeR <- cbind(cycleTimeR, tempColumn )
}
colnames(cycleTimeR) <- RoutineNames
#
###

### Finally merge All columns together into a single data.frame
#
#
columnPerAlarm <- 5
finalFrameP <- cbind()
for(i in 1:(ncol(wingNotesP)/columnPerAlarm )){
	whistleNumber <- colnames(wingNotesP)[i*columnPerAlarm-columnPerAlarm +1]
	peakCol <- peaktroughListP[,which(colnames(peaktroughListP) == whistleNumber )]
	CycleCol <- cycleListP[,which(colnames(cycleListP) == whistleNumber )]
	timeCol <- cycleTimeP[,which(colnames(cycleTimeP ) == whistleNumber )]

	finalFrameP <- cbind(finalFrameP, wingNotesP[, (i*columnPerAlarm -columnPerAlarm +1):(i*columnPerAlarm )], peakCol, CycleCol, timeCol )
}


finalFrameR <- cbind()
for(i in 1:(ncol(wingNotesR)/columnPerAlarm )){
	whistleNumber <- colnames(wingNotesR)[i*columnPerAlarm -columnPerAlarm +1]
	peakCol <- peaktroughListR[,which(colnames(peaktroughListR) == whistleNumber )]
	CycleCol <- cycleListR[,which(colnames(cycleListR) == whistleNumber )]
	timeCol <- cycleTimeR[,which(colnames(cycleTimeR ) == whistleNumber )]

	finalFrameR <- cbind(finalFrameR, wingNotesR[, (i*columnPerAlarm -columnPerAlarm +1):(i*columnPerAlarm )], peakCol, CycleCol, timeCol )
}
finalFrameR[335,19:21] <- NA
#
###

#####
##Now that we have the full Data set we go through and pull out just the important bits
## For each Note:
##1) The duration since start of cycle for the start and end of the Note
##2) The wing angle during the start and end of each note
##3) As 1) but expressed as a percentage of the wing beat cycle
##4) as 2) but expressed as a percentage of the range of the flap
get.Note.Cycle.Times <- function( cycleFullFrame, flip180 ){
	cycleFullFrame <- as.data.frame(cycleFullFrame)
	cycleFullFrame$timeCol <- as.numeric(as.character(cycleFullFrame$timeCol))
	cycleFullFrame$wing<- as.numeric(as.character(cycleFullFrame$wing))
	cycleFullFrame$CycleCol<- as.numeric(as.character(cycleFullFrame$CycleCol))
	startEndTimes <- cbind()
	noteList <- rbind()
	tempEntry <- cbind()
	tempClap <- cbind()
	for(i in 2:nrow(cycleFullFrame)){
		##Detect high note start
		if(!is.na(cycleFullFrame$highNote[i]) & is.na(cycleFullFrame$highNote[i-1])){
			wingStartPercent <- NA
			frameTime <- cycleFullFrame$timeCol[i+1]-cycleFullFrame$timeCol[i]	
			if( (abs(frameTime - 0.002) < 0.000001) & !is.na(frameTime )){
				wing1 <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-1], flip180)
				wing2 <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-2], flip180)
				wingStartPercent <- (wing1 + wing2)/2
			}else if((abs(frameTime - 0.004) < 0.000001) & !is.na(frameTime )){
				wingStartPercent <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-1], flip180)
				#print(c(0.004, wingStartPercent ))
			} else{ 
				print('ERROR')
			}
			print(wingStartPercent )
			#transDelay 
			#wingStartPercent <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i], flip180)
			startCycle <- cycleFullFrame$CycleCol[i]
			timeStartPercent <- get.Time.Percent(cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$timeCol[i])
			#print(c('High', i))
			tempEntry <- cbind(NoteType = 'High', 
							wingAngleStart = cycleFullFrame$wing[i],
							wingStartPercent, 
							startTime = cycleFullFrame$timeCol[i],
							timeStartPercent )
		}
		##Detect low note Start
		if(!is.na(cycleFullFrame$lowNote[i]) & is.na(cycleFullFrame$lowNote[i-1])){
			wingStartPercent <- NA
			frameTime <- cycleFullFrame$timeCol[i+1]-cycleFullFrame$timeCol[i]	
			if( (abs(frameTime - 0.002) < 0.000001) & !is.na(frameTime )){
				wing1 <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-1], flip180)
				wing2 <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-2], flip180)
				wingStartPercent <- (wing1 + wing2)/2		
			}else if((abs(frameTime - 0.004) < 0.000001) & !is.na(frameTime )){
				wingStartPercent <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-1], flip180)
				#print(c(0.004, wingStartPercent ))
			} else{ 
				print('ERROR')
			}
			startCycle <- cycleFullFrame$CycleCol[i]
			timeStartPercent <- get.Time.Percent(cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$timeCol[i])
			#print(c('Low', 1))
			tempEntry <- cbind(NoteType = 'Low', 
							wingAngleStart = cycleFullFrame$wing[i],
							wingStartPercent, 
							startTime = cycleFullFrame$timeCol[i],
							timeStartPercent )
		}
		##Detect clap start
		if(!is.na(cycleFullFrame$clap[i]) & is.na(cycleFullFrame$clap[i-1])){
			wingStartPercent <- NA
			frameTime <- cycleFullFrame$timeCol[i+1]-cycleFullFrame$timeCol[i]	
			if( (abs(frameTime - 0.002) < 0.000001) & !is.na(frameTime )){
				wing1 <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-1], flip180)
				wing2 <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-2], flip180)
				wingStartPercent <- (wing1 + wing2)/2		
			}else if((abs(frameTime - 0.004) < 0.000001) & !is.na(frameTime )){
				wingStartPercent <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-1], flip180)
				#print(c(0.004, wingStartPercent ))
			} else{ 
				print('ERROR')
			}
			if( cycleFullFrame$timeCol[i] - transDelay < 0 && !is.na(cycleFullFrame$timeCol[i])){
				startCycleClap <- cycleFullFrame$CycleCol[i] -1
				#print('early')
			} else{
				startCycleClap <- cycleFullFrame$CycleCol[i]
				#print('norm')
			}
			timeStartPercent <- get.Time.Percent(cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$timeCol[i])
			#print(c('clap',i))
			tempClap <- cbind(NoteType = 'Clap', 
							wingAngleStart = cycleFullFrame$wing[i],
							wingStartPercent, 
							startTime = get.Total.Time(cycleFullFrame, startCycleClap, i),
							timeStartPercent )
		}

		##Detect high note End and add full entry to the note list
		if(is.na(cycleFullFrame$highNote[i]) & !is.na(cycleFullFrame$highNote[i-1])){
			frameTime <- cycleFullFrame$timeCol[i+1]-cycleFullFrame$timeCol[i]	
			wingEndPercent <- NA
			if( (abs(frameTime - 0.002) < 0.000001) & !is.na(frameTime )){
				wing1 <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-1], flip180)
				wing2 <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-2], flip180)
				wingEndPercent <- (wing1 + wing2)/2		
			}else if((abs(frameTime - 0.004) < 0.000001) & !is.na(frameTime )){
				wingEndPercent <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-1], flip180)
				#print(c(0.004, wingStartPercent ))
			} else{ 
				print('ERROR')
			}
			totalTime <- get.Total.Time(cycleFullFrame, startCycle, i)
			timeEndPercent <- get.Time.Percent(cycleFullFrame, cycleFullFrame$CycleCol[i], totalTime )
			tempEntry <- cbind(tempEntry, 
						wingAngleEnd = cycleFullFrame$wing[i], 
						wingEndPercent,
						endTime = totalTime,
						timeEndPercent,
						cycleDuration = max( cycleFullFrame[cycleFullFrame$CycleCol == startCycle,]$timeCol))
			rownames(tempEntry) <- colnames(cycleFullFrame)[1]
			tempEntry <- cbind( tempEntry, takeOffID = colnames(cycleFullFrame)[1])
			#print(tempEntry)
			noteList <- rbind(noteList, tempEntry)
			#tempEntry <- cbind()
		}
		##Detect low note end and add full entry to the note list
		if(is.na(cycleFullFrame$lowNote[i]) & !is.na(cycleFullFrame$lowNote[i-1])){
			frameTime <- cycleFullFrame$timeCol[i+1]-cycleFullFrame$timeCol[i]	
			wingEndPercent <- NA
			if( (abs(frameTime - 0.002) < 0.000001) & !is.na(frameTime )){
				wing1 <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-1], flip180)
				wing2 <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-2], flip180)
				wingEndPercent <- (wing1 + wing2)/2		
			}else if((abs(frameTime - 0.004) < 0.000001) & !is.na(frameTime )){
				wingEndPercent <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-1], flip180)
				#print(c(0.004, wingStartPercent ))
			} else{ 
				print('ERROR')
			}
			totalTime <- get.Total.Time(cycleFullFrame, startCycle, i)
			timeEndPercent <- get.Time.Percent(cycleFullFrame, cycleFullFrame$CycleCol[i], totalTime )
			tempEntry<- cbind(tempEntry, 
						wingAngleEnd = cycleFullFrame$wing[i], 
						wingEndPercent,
						endTime = totalTime,
						timeEndPercent, 
						cycleDuration = max( cycleFullFrame[cycleFullFrame$CycleCol == startCycle,]$timeCol))
			rownames(tempEntry) <- colnames(cycleFullFrame)[1]
			tempEntry <- cbind( tempEntry, takeOffID = colnames(cycleFullFrame)[1])

			#print(tempEntry )
			noteList <- rbind(noteList,  tempEntry)
			#tempEntry <- cbind()
		}
		##Detect Clap end and add full entry to the note list
		if(is.na( cycleFullFrame$clap[i]) & !is.na(cycleFullFrame$clap[i-1])){
			wingEndPercent <- NA
			frameTime <- cycleFullFrame$timeCol[i+1]-cycleFullFrame$timeCol[i]	
			if( (abs(frameTime - 0.002) < 0.000001) & !is.na(frameTime )){
				wing1 <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-1], flip180)
				wing2 <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-2], flip180)
				wingEndPercent <- (wing1 + wing2)/2		
			}else if((abs(frameTime - 0.004) < 0.000001) & !is.na(frameTime )){
				wingEndPercent <- get.Wing.Percent( cycleFullFrame, cycleFullFrame$CycleCol[i], cycleFullFrame$wing[i-1], flip180)
				#print(c(0.004, wingStartPercent ))
			} else{ 
				print('ERROR')
			}
			totalTime <- get.Total.Time(cycleFullFrame, startCycleClap, i)
			timeEndPercent <- get.Time.Percent(cycleFullFrame, cycleFullFrame$CycleCol[i], totalTime )
			tempClap <- cbind(tempClap , 
						wingAngleEnd = cycleFullFrame$wing[i], 
						wingEndPercent,
						endTime = totalTime,
						timeEndPercent,
						cycleDuration = max( cycleFullFrame[cycleFullFrame$CycleCol == startCycleClap,]$timeCol))
			rownames(tempClap ) <- colnames(cycleFullFrame)[1]
			tempClap <- cbind( tempClap, takeOffID = colnames(cycleFullFrame)[1])

			#print(tempClap)
			noteList <- rbind(noteList, tempClap )
			#tempEntry <- cbind()

		}

	}
	#colnames(noteList) <- c('NoteType', 'wingAngleStart', 'startTime', 'wingAngleEnd', 'endTime') 
	return(noteList )
}
#
###
#
###
# get the precentage(%) wing-angle of the currently frame by 
# finding the lowest and highest angle ofthe current cycle and 
# comparing that to the angle at the current frame
#Input: takeoffFrame - data.frame for the current take-off
# 	currentCycle - Number for the currently cycle
# 	currentWingAngle - The wing angle that you want converted to a percentage of wing-angle
#Output: finalWingAngle - current Wing angle expressed as a pervent between 
#	wing max and wing min
get.Wing.Percent <- function(takeoffFrame , startCycle, currentWingAngle, flip180 ){
	if(!is.na(currentWingAngle )){
		cycleFrame <- takeoffFrame[takeoffFrame$CycleCol == startCycle,]
		wingMax <- max( as.numeric(as.character(cycleFrame[, 2])), na.rm = TRUE)
		wingMin <- min( as.numeric(as.character(cycleFrame[, 2])), na.rm = TRUE)
		#print(wingMax )
		#print(wingMin )
		#print(currentWingAngle[1] )
		if( flip180 ){
			finalWingAngle <- (as.numeric(as.character(currentWingAngle)) - wingMax ) / (wingMin - wingMax )
		#	print(finalWingAngle )
		}else {
			finalWingAngle <- (as.numeric(as.character(currentWingAngle)) - wingMin) / (wingMax - wingMin)
		}

		#print(c( finalWingAngle, 'percent') )
		return(finalWingAngle)
	}else{
		return(NA)
	}
}
#
###
#
###
# Extract time from the start of the current cycle
# Note if the end point is in the next cycle add that time to the 
# maximum time from the previous cycle
#Input: takeoffFrame - data.frame for the current take-off
# 	startingCycle - The cycle number for the start of the current note
# 	currentIndent - The indent for the frame you require the time of
#Output: totalTime - current time expressed as a precent of total cycle time
get.Total.Time <- function(takeoffFrame, startCycle, currentIndent ){
	#print(c( 'start', startCycle))
	#print(c( 'current', takeoffFrame$CycleCol[currentIndent]))
	if(startCycle< takeoffFrame$CycleCol[currentIndent]){
		startCycleSubset <- takeoffFrame[takeoffFrame$CycleCol == startCycle,]
		maxTime <- max( startCycleSubset$timeCol)
		totalTime <- maxTime + takeoffFrame$timeCol[currentIndent]
		#print(totalTime )
	}else {
		totalTime <- takeoffFrame$timeCol[currentIndent]
		#print(totalTime )
	}
	return(totalTime )
}
#
###
#
###
# Express the time at the current frame as a percentage of the total 
# time of the current cycle
#Input: takeoffFrame - data.frame for the current take-off
# 	currentCycle - Number for the currently cycle
# 	currentTime - The wing angle that you want converted to a percentage of wing-angle
#Output: finalPercentTime - current time expressed as a precent of total cycle time
get.Time.Percent <- function(takeoffFrame, currentCycle, currentTime ){
	if(!is.na(currentTime )){
		cycleFrame <- takeoffFrame[takeoffFrame$CycleCol == currentCycle,]
		timeMax <- max( as.numeric(as.character(cycleFrame$timeCol)), na.rm = TRUE)
		#print(timeMax )
		#print(currentTime)
		finalPercentTime <- as.numeric(as.character(currentTime)) / timeMax 
		#print(c( finalPercentTime , 'percent') )
		return(finalPercentTime )
	}else{
		return(NA)
	}
}
#
###
##
#####

#####

###UGh should have already removed any 0's and NaNs
for( i in 1:ncol(finalFrameP)){
	##First set all NA values (0 & NaN) to R's NA
	#finalFrameP[,i][finalFrameP[,i] == '0'] <- NA
	finalFrameP[,i][finalFrameP[,i] == NaN] <- NA
}
for( i in 1:ncol(finalFrameR)){
	##First set all NA values (0 & NaN) to R's NA
	#finalFrameR[,i][finalFrameR[,i] == 0] <- NA
	finalFrameR[,i][finalFrameR[,i] == NaN] <- NA
}
noteDataP <- data.frame()
colsPerTakeOff <- 8
for(i in 1:(ncol(finalFrameP)/colsPerTakeOff )){
	noteDataP <- rbind(noteDataP, get.Note.Cycle.Times(finalFrameP[,(i*colsPerTakeOff -colsPerTakeOff +1):(i*colsPerTakeOff )], Prompted180[i]))
}
#noteDataP <- cbind( takeoffNo = rownames(noteDataP), noteDataP)
rownames(noteDataP) <- 1:nrow(noteDataP)
noteDataP <- as.data.frame(noteDataP, stringsAsFactors = F)
noteDataP <- cbind(takeoffType = rep('Alarm', nrow(noteDataP) ), noteDataP)

noteDataR <- rbind()
for(i in 1:(ncol(finalFrameR)/7)){
	noteDataR <- rbind(noteDataR, get.Note.Cycle.Times(finalFrameR[,(i*colsPerTakeOff -colsPerTakeOff +1):(i*colsPerTakeOff )], finalR180[i]))
}
#noteDataR <- cbind( takeoffNo = rownames(noteDataR), noteDataR)
rownames(noteDataR) <- 1:nrow(noteDataR)
noteDataR <- as.data.frame(noteDataR, stringsAsFactors = F)
noteDataR <- cbind( takeoffType = rep('Routine', nrow(noteDataR)), noteDataR)

fullNoteData <- rbind(noteDataR, noteDataP)
fullNoteData$NoteType <- as.factor(fullNoteData$NoteType)
fullNoteData$takeOffID <- as.character(fullNoteData$takeOffID)
fullNoteData$takeOffID[79:89] <- '21' #rename the alarm takeOffID due to overlap
fullNoteData$startTime <- as.numeric(fullNoteData$startTime)
fullNoteData$endTime <- as.numeric(fullNoteData$endTime)
fullNoteData$wingAngleStart <- as.numeric(fullNoteData$wingAngleStart)
fullNoteData$wingAngleEnd <- as.numeric(fullNoteData$wingAngleEnd)
fullNoteData$wingStartPercent <- as.numeric(fullNoteData$wingStartPercent)
fullNoteData$wingEndPercent <- as.numeric(fullNoteData$wingEndPercent )
fullNoteData$timeStartPercent <- as.numeric(fullNoteData$timeStartPercent)
fullNoteData$timeEndPercent <- as.numeric(fullNoteData$timeEndPercent )
fullNoteData$cycleDuration <- as.numeric(fullNoteData$cycleDuration )

### Remove 1 data point do to weird values maybe look into the cause
fullNoteData[24, ] <- NA #Need to track this down would be 31

###Split data into high and low notes and analyse start and end times
##

highR <-noteDataR[noteDataR$NoteType == 'High',]
lowR <-noteDataR[noteDataR$NoteType == 'Low',]
highP <-noteDataP[noteDataP$NoteType == 'High',]
lowP <-noteDataP[noteDataP$NoteType == 'Low',]
tempNotes <- fullNoteData[fullNoteData$NoteType != 'Clap',]

tempNotes$NoteType <- factor(tempNotes$NoteType)

boxplot(startTime ~ NoteType+takeoffType, data = fullNoteData )
boxplot(endTime ~ NoteType+takeoffType, data = fullNoteData )
boxplot(endTime - startTime ~ NoteType+takeoffType+takeOffID, data = tempNotes )
boxplot(endTime - startTime ~ NoteType+takeoffType, data = tempNotes )
boxplot(wingStartPercent ~ NoteType+takeoffType, data = fullNoteData )
boxplot(wingEndPercent ~ NoteType+takeoffType, data = fullNoteData )
boxplot(timeStartPercent ~ NoteType+takeoffType, data = fullNoteData )
boxplot(timeEndPercent ~ NoteType+takeoffType, data = fullNoteData )

boxplot(startTime ~ NoteType, data = fullNoteData[fullNoteData$takeoffType == 'Alarm',] )

medianData <- aggregate( endTime - startTime ~ takeOffID:NoteType:takeoffType, data = tempNotes, median)
colnames(medianData)[4] <- 'duration'
boxplot(duration ~ NoteType+takeoffType, data = medianData )

boxplot(startTime ~ takeoffNo, data = fullNoteData )
alarData <- fullNoteData[fullNoteData$takeoffType == 'Alarm']

fullGLM1 <- glm( startTime ~ NoteType * (takeoffType + takeoffNo) , data = fullNoteData )
fullGLM2 <- glm( startTime ~ NoteType, data = fullNoteData[fullNoteData$takeoffType == 'Alarm',] )

fullGLM3 <- glm( wingAngleStart ~ NoteType * takeoffNo , data = fullNoteData[fullNoteData$takeoffType == 'Alarm',] )

plot( startTime ~ NoteType*takeoffType, data = fullNoteData )
plot( startTime ~ NoteType, data = fullNoteData )
glm(startTime ~ (1|V1)


alarmData <- fullNoteData[fullNoteData$takeoffType == 'Alarm',]
alarmHighData <- alarmData [alarmData $NoteType == 'High',]
alarmLowData <- alarmData [alarmData $NoteType == 'Low',]
plot(alarmLowData$startTime )
plot(alarmHighData $startTime )
plot(alarmLowData$endTime )
plot(alarmHighData $endTime )
median(alarmHighData$startTime, na.rm = T)
median(alarmLowData$startTime, na.rm = T)
median(alarmHighData$endTime , na.rm = T)
median(alarmLowData$endTime , na.rm = T)

plot(highR$startTime )
plot(lowR$startTime )
plot(highR$endTime )
plot(lowR$endTime )

plot(highP$wingStartPercent )
plot(lowP$wingStartPercent )
plot(highP$wingEndPercent )
plot(lowP$wingEndPercent )


plot(highR$wingStartPercent )
plot(lowR$wingStartPercent )
plot(highR$wingEndPercent )
plot(lowR$wingEndPercent )


plot(highR$wingAngleStart )
plot(lowR$wingAngleStart )
plot(highR$wingAngleEnd )
plot(lowR$wingAngleEnd )


plot(alarmLowData$wingAngleStart)
			############
     #####################################
############## POLAR CICLE PLOTTING ##############
     #####################################
			############
fullNoteData <- fullNoteData[-24,]

#make data set (DELETE THIS)
set.seed(12345)
n = 117
a = data.frame(factor = sample(letters[1:1], n, replace = TRUE),
		x = rnorm(n), y = runif(n))

DataA = data.frame(factor = sample(letters[1:1]),
				whistleType = fullNoteData$NoteType, 
				x = fullNoteData$timeStartPercent,
				y = runif(n),
				z = fullNoteData$timeEndPercent)
DataB <- DataA[-which(is.na(DataA$x)),]
a = DataB 
library(circlize)

par(mar = c(1, 1, 1, 1), lwd = 0.1, cex = 0.7)
circos.par("default.track.height" = 0.1)
circos.initialize(factors = a$factor, x = a$x)
circos.trackPlotRegion(factors = a$factor, y = a$y)
#col = rep(c("#FF0000", "#00FF00"), 4)
#circos.trackPoints(a$factor, a$x, a$y, col = col, pch = 16, cex = 0.5)
#circos.text(-1, 0.5, "left", sector.index = "a", track.index = 1)
#circos.text(1, 0.5, "right", sector.index = "a")

#bgcol = rep(c("#EFEFEF", "#CCCCCC"), 4)
#circos.trackHist(a$factor, a$x, bg.col = bgcol, col = NA, breaks = 40)

circos.trackPlotRegion(factors = a$factor, x = a$x, y = a$y,
	panel.fun = function(x, y) {
	grey = c("#FFFFFF", "#CCCCCC", "#999999")
	i = get.cell.meta.data("sector.numeric.index")
	circos.updatePlotRegion(bg.col = grey[i %% 3 + 1])
	circos.points( a$x[a$whistleType == 'High'], a$y[a$whistleType == 'High'], col = "red", pch = 16, cex = 0.6)
	circos.points( a$x[a$whistleType == 'Low'], a$y[a$whistleType == 'Low'], col = "blue", cex = 0.6)})

circos.trackPlotRegion(factors = a$factor, x = a$z, y = a$y,
	panel.fun = function(x, y) {
	grey = c("#FFFFFF", "#CCCCCC", "#999999")
	i = get.cell.meta.data("sector.numeric.index")
	circos.updatePlotRegion(bg.col = grey[i %% 3 + 1])
	circos.points( a$z[a$whistleType == 'High'], a$y[a$whistleType == 'High'], col = "red", pch = 16, cex = 0.6)
	circos.points( a$z[a$whistleType == 'Low'], a$y[a$whistleType == 'Low'], col = "blue", cex = 0.6)
	circos.rect(mean(a$x[a$whistleType == 'Low']), 0, mean(a$z[a$whistleType == 'Low']), 1, col = "blue" )
	circos.rect(mean(a$x[a$whistleType == 'High']), 0, mean(a$z[a$whistleType == 'High']), 1 , col = "red" )
	})

rectData <- data.frame(xleft = mean(a$x[a$whistleType == 'Low']), 
		ybottom = 0,
		xright = mean(a$z[a$whistleType == 'Low']),
		ytop = 1)
#xleft = x for the left bottom points
#ybottom = y for the left bottom points
#xright = x for the right top points
#ytop = y for the right top points

circos.updatePlotRegion(sector.index = "d", track.index = 2)
circos.points(x = -2:2, y = rep(0, 5))
			############
     #####################################
############## POLAR CICLE PLOTTING ##############
     #####################################
			############
			GG PLOT TIEM

library(ggplot2)

#####Erronious value correction
#fullNoteData[24,11] <- 1.13
fullNoteData[31,11] <- 1.13
# if < 0.2 add 1
fullNoteData$timeEndPercent[fullNoteData$NoteType == 'Low' & fullNoteData$timeEndPercent < 0.2 & !is.na(fullNoteData$timeEndPercent)] <- fullNoteData$timeEndPercent[fullNoteData$NoteType == 'Low' & fullNoteData$timeEndPercent < 0.2 & !is.na(fullNoteData$timeEndPercent) ] +1
#fullNoteData$timeEnd[fullNoteData$NoteType == 'Low' & fullNoteData$timeEnd < 0.2 & !is.na(fullNoteData$timeEnd)] <- fullNoteData$timeEndPercent[fullNoteData$NoteType == 'Low' & fullNoteData$timeEnd < 0.2 & !is.na(fullNoteData$timeEnd) ] +1
fullNoteData$timeEndPercent[fullNoteData$NoteType == 'Clap' & fullNoteData$timeEndPercent < 0.3 & !is.na(fullNoteData$timeEndPercent)] <- fullNoteData$timeEndPercent[fullNoteData$NoteType == 'Clap' & fullNoteData$timeEndPercent < 0.3 & !is.na(fullNoteData$timeEndPercent) ] +1
fullNoteData$timeStartPercent[fullNoteData$NoteType == 'Clap' & fullNoteData$timeStartPercent < 0.3 & !is.na(fullNoteData$timeStartPercent )] <- fullNoteData$timeStartPercent[fullNoteData$NoteType == 'Clap' & fullNoteData$timeStartPercent < 0.3 & !is.na(fullNoteData$timeStartPercent ) ] +1
tempDurationEnd <- fullNoteData$timeEndPercent * fullNoteData$cycleDuration - transDelay 
tempDurationStart <- fullNoteData$timeStartPercent * fullNoteData$cycleDuration - transDelay 
levels(fullNoteData$NoteType) <- c(levels(fullNoteData$NoteType), 'downClap')
fullNoteData$NoteType[(fullNoteData$NoteType == 'Clap' & fullNoteData$timeStartPercent <= 0.8)] <- 'downClap'

#fullNoteData$endTime[fullNoteData$NoteType == 'Clap' & fullNoteData$endTime< 0.03 & !is.na(fullNoteData$endTime)] <- fullNoteData$endTime[fullNoteData$NoteType == 'Clap' & fullNoteData$endTime< 0.03 & !is.na(fullNoteData$endTime) ] +1
#fullNoteData$startTime[fullNoteData$NoteType == 'Clap' & fullNoteData$startTime< 0.03 & !is.na(fullNoteData$startTime)] <- fullNoteData$startTime[fullNoteData$NoteType == 'Clap' & fullNoteData$startTime< 0.03 & !is.na(fullNoteData$startTime) ] +1

lowData <- data.frame(meanStart = mean(fullNoteData$timeStartPercent[fullNoteData$NoteType == 'Low'], na.rm = T), 
		meanEnd = mean(fullNoteData$timeEndPercent[fullNoteData$NoteType == 'Low'], na.rm = T))
highData <- data.frame(meanStart = mean(fullNoteData$timeStartPercent[fullNoteData$NoteType == 'High'], na.rm = T), 
		meanEnd = mean(fullNoteData$timeEndPercent[fullNoteData$NoteType == 'High'], na.rm = T))
clapLowData <- data.frame(meanStart = mean(fullNoteData$timeStartPercent[(fullNoteData$NoteType == 'Clap' & fullNoteData$timeStartPercent <= 0.8)], na.rm = T),
				meanEnd = mean(fullNoteData$timeEndPercent[(fullNoteData$NoteType == 'Clap' & fullNoteData$timeEndPercent <= 0.8)], na.rm = T))
clapHighData <- data.frame(meanStart = mean(fullNoteData$timeStartPercent[(fullNoteData$NoteType == 'Clap' & fullNoteData$timeStartPercent >= 0.8)], na.rm = T),
				meanEnd = mean(fullNoteData$timeEndPercent[(fullNoteData$NoteType == 'Clap' & fullNoteData$timeEndPercent >= 0.8)], na.rm = T))

lowWingData <- data.frame(meanStart = mean(fullNoteData$wingStartPercent[fullNoteData$NoteType == 'Low'], na.rm = T), 
		meanEnd = mean(fullNoteData$wingEndPercent[fullNoteData$NoteType == 'Low'], na.rm = T))
highWingData <- data.frame(meanStart = mean(fullNoteData$wingStartPercent[fullNoteData$NoteType == 'High'], na.rm = T), 
		meanEnd = mean(fullNoteData$wingEndPercent[fullNoteData$NoteType == 'High'], na.rm = T))
clapLowWingData <- data.frame(meanStart = mean(fullNoteData$wingStartPercent[(fullNoteData$NoteType == 'Clap' & fullNoteData$wingStartPercent<= 0.5)], na.rm = T),
				meanEnd = mean(fullNoteData$wingEndPercent[(fullNoteData$NoteType == 'Clap' & fullNoteData$wingEndPercent <= 0.5)], na.rm = T))
clapHighWingData <- data.frame(meanStart = mean(fullNoteData$wingStartPercent[(fullNoteData$NoteType == 'Clap' & fullNoteData$wingStartPercent>= 0.5)], na.rm = T),
				meanEnd = mean(fullNoteData$wingEndPercent[(fullNoteData$NoteType == 'Clap' & fullNoteData$wingEndPercent >= 0.5)], na.rm = T))

clapHighWingData <- data.frame(meanStart = mean(fullNoteData$wingStartPercent[(fullNoteData$NoteType == 'downClap' & fullNoteData$wingStartPercent<= 0.5)], na.rm = T),
				meanEnd = mean(-fullNoteData$wingEndPercent[(fullNoteData$NoteType == 'downClap' & fullNoteData$wingEndPercent <= 0.5)], na.rm = T))


lowTimeAbs <- data.frame(meanStart = mean(fullNoteData$startTime[fullNoteData$NoteType == 'Low'], na.rm = T), 
		meanEnd = mean(fullNoteData$endTime[fullNoteData$NoteType == 'Low'], na.rm = T))
highTimeAbs <- data.frame(meanStart = mean(fullNoteData$startTime[fullNoteData$NoteType == 'High'], na.rm = T), 
		meanEnd = mean(fullNoteData$endTime[fullNoteData$NoteType == 'High'], na.rm = T))

clapLowData <- data.frame(meanStart = mean(tempDurationStart[(fullNoteData$NoteType == 'Clap' & fullNoteData$timeStartPercent <= 0.8)], na.rm = T),
				meanEnd = mean(tempDurationEnd[(fullNoteData$NoteType == 'Clap' & fullNoteData$timeEndPercent <= 0.8)], na.rm = T))
clapHighData <- data.frame(meanStart = mean(tempDurationStart[(fullNoteData$NoteType == 'Clap' & fullNoteData$timeStartPercent >= 0.8)], na.rm = T),
				meanEnd = mean(tempDurationEnd[(fullNoteData$NoteType == 'Clap' & fullNoteData$timeEndPercent >= 0.8)], na.rm = T))

tempDurationEnd 
clapLowData - transDelay 
clapHighData - transDelay

wingstartGLM <- glm(wingStartPercent~ NoteType, data=fullNoteData)

startGLM <- glm(timeStartPercent ~ NoteType, data=fullNoteData)
endGLM <- glm(timeEndPercent ~ NoteType, data=fullNoteData)
plot(timeStartPercent ~ NoteType, data=fullNoteData)
plot(timeEndPercent ~ NoteType, data=fullNoteData)

startSD = sqrt(diag(vcov(startGLM )))
startIntervals <- data.frame(ymin=-startSD *1.96+coef(startGLM ),ymax=startSD *1.96+coef(startGLM ))
startIntervals [2,] <- startIntervals [2,] + startGLM$coefficients[1]
startIntervals <- cbind(startIntervals, xmin = c(3.5, 3.5), xmax = c(3.5, 3.5))

endSD = sqrt(diag(vcov(endGLM )))
endIntervals <- data.frame(ymin=-endSD *1.96+coef(endGLM ),ymax=endSD *1.96+coef(endGLM ))
endIntervals [2,] <- endIntervals[2,] + endGLM$coefficients[1]
endIntervals <- cbind(endIntervals , xmin = c(3.5, 3.5), xmax = c(3.5, 3.5))

### Get absolute standard errors for Paper text
startAbsGLM <- glm(timeStartPercent * cycleDuration~ NoteType, data=fullNoteData)
summary(startAbsGLM )
startSD = sqrt(diag(vcov(startAbsGLM )))
startIntervals <- data.frame(ymin=-startSD *1.96+coef(startAbsGLM ),ymax=startSD *1.96+coef(startAbsGLM ))
startIntervals [2,] <- startIntervals [2,] + startAbsGLM$coefficients[1]
startIntervals [3,] <- startIntervals [3,] + startAbsGLM$coefficients[1]
startIntervals [4,] <- startIntervals [4,] + startAbsGLM$coefficients[1]
(startIntervals[1,2] - startIntervals[1,1])/2
(startIntervals[2,2] - startIntervals[2,1])/2
(startIntervals[3,2] - startIntervals[3,1])/2
(startIntervals[4,2] - startIntervals[4,1])/2
(startIntervals[1,2] + startIntervals[1,1])/2
(startIntervals[2,2] + startIntervals[2,1])/2
(startIntervals[3,2] + startIntervals[3,1])/2
(startIntervals[4,2] + startIntervals[4,1])/2

endAbsGLM <- glm(timeEndPercent * cycleDuration ~ NoteType, data=fullNoteData)
summary(endAbsGLM )
endSD = sqrt(diag(vcov(endAbsGLM )))
endIntervals <- data.frame(ymin=-endSD *1.96+coef(endAbsGLM ),ymax=endSD *1.96+coef(endAbsGLM ))
endIntervals [2,] <- endIntervals[2,] + endAbsGLM $coefficients[1]
endIntervals [3,] <- endIntervals[3,] + endAbsGLM $coefficients[1]
endIntervals [4,] <- endIntervals[4,] + endAbsGLM $coefficients[1]
(endIntervals [1,2] - endIntervals [1,1])/2
(endIntervals [2,2] - endIntervals [2,1])/2
(endIntervals [3,2] - endIntervals [3,1])/2
(endIntervals [4,2] - endIntervals [4,1])/2
(endIntervals [1,2] + endIntervals [1,1])/2
(endIntervals [2,2] + endIntervals [2,1])/2
(endIntervals [3,2] + endIntervals [3,1])/2
(endIntervals [4,2] + endIntervals [4,1])/2
transDelay 

#wing Percent
subsetHL <- fullNoteData[fullNoteData$NoteType != 'Clap',]
startWingGLM <- glm(wingStartPercent ~ NoteType, data=subsetHL )
summary(startWingGLM )
startSD = sqrt(diag(vcov(startWingGLM )))
startIntervals <- data.frame(ymin=-startSD *1.96+coef(startWingGLM ),ymax=startSD *1.96+coef(startWingGLM ))
startIntervals [2,] <- startIntervals [2,] + startWingGLM$coefficients[1]
(startIntervals[1,2] - startIntervals[1,1])/2
(startIntervals[2,2] - startIntervals[2,1])/2
(startIntervals[3,2] - startIntervals[3,1])/2
1-(startIntervals[1,2] + startIntervals[1,1])/2
1-(startIntervals[2,2] + startIntervals[2,1])/2
1-(startIntervals[3,2] + startIntervals[3,1])/2


# Create test data.
dat = data.frame(ymin=c(highData$meanStart, highData$meanEnd, lowData$meanStart, lowData$meanEnd-1 ), 
	ymax=c(highData$meanEnd, lowData$meanStart, lowData$meanEnd, highData$meanStart ), 
	category=c("High", "Empty", "Low", "Empty"))

# Add addition columns, needed for drawing with geom_rect.
dat = dat[order(dat$ymin), ]

##now subtract mean transition delay for sound
dat[,1:2] <- dat[,1:2] - delayPercent 

## Generate the 95% confidance inverval line values for a data category
get.Intervals <- function(min, max){
	intervalFrame<- data.frame(xstart = c(3.5, 3.25, 3.25),
			ystart = c(minus.one(min), minus.one(min), minus.one(max)),
			xend = c(3.5, 3.75, 3.75), 
			yend= c(minus.one(max), minus.one(min), minus.one(max)))

	return(intervalFrame)
}
minus.one <- function(value){
	if(value>1){
		return(value )
	}else{
		return(value)
	}
}
intervalData <- data.frame()
intervalData <- rbind(intervalData, get.Intervals(endIntervals$ymin[1], endIntervals$ymax[1]))
intervalData <- rbind(intervalData, get.Intervals(endIntervals$ymin[2], endIntervals$ymax[2]))
intervalData <- rbind(intervalData, get.Intervals(startIntervals$ymin[1], startIntervals$ymax[1]))
intervalData <- rbind(intervalData, get.Intervals(startIntervals$ymin[2], startIntervals$ymax[2]))

##now subtract mean transition delay for sound
intervalData[,c(2,4)] <- intervalData[,c(2,4)] - delayPercent 

start_Value <- 0.0174532925 * 360 * (lowData$meanEnd-1)
cbPalette <- c("#FFFFFF", "#D53E4F", "#3288BD")


# To use for fills, add
  scale_fill_manual(values=cbPalette)

p2 = 	ggplot() +
     	geom_rect(data=dat, aes(fill=category, ymax=ymax, ymin=ymin, xmax=4, xmin=3), ylim=c(0, 1), colour="grey30") +
	coord_polar(start = start_Value, theta="y") +
	geom_segment(data = intervalData, mapping=aes(x=xstart, y=ystart, xend=xend, yend=yend)) +
	#geom_segment(x = 3.5, y = 0, xend = 2.5, yend= 0.9, arrow = arrow()) +
	ylim(c(lowData$meanEnd-1, lowData$meanEnd)) +
	scale_fill_manual(values=cbPalette) + 
	xlim(c(0, 4)) +
	theme_bw() +
	theme(panel.grid=element_blank()) +
	theme(axis.text=element_blank()) +
	theme(axis.ticks=element_blank()) +
	labs(title="Wing Beat plot")

plot(p2)
arrowData <- data.frame(x = c(2.5, 2.5, 2.5), 
				y = c(highData$meanEnd-1, highData$meanEnd/3, 2*highData$meanEnd/3),
				xend = c(2.5, 2.5, 2.5), 
				yend = c(highData$meanEnd/3, 2*highData$meanEnd/3, highData$meanEnd))

modDat <- dat[c(-1, -3),]
p1 = 	ggplot() +
	geom_rect( aes(fill="Empty", ymax=highData$meanEnd, ymin=highData$meanEnd-1, xmax=4, xmin=3), ylim=c(0, 1), colour="grey") +
	geom_rect(data=modDat, aes(fill=category, ymax=ymax, ymin=ymin, xmax=4, xmin=3), ylim=c(0, 1), colour="grey30") +
	geom_segment(data = intervalData, mapping=aes(x=xstart, y=ystart, xend=xend, yend=yend)) +
	#geom_segment(data = arrowData, aes(x = x, y = y, xend = xend, yend= yend), arrow = arrow(length = unit(0.5, "cm"), ends = "last")) +
	coord_cartesian(ylim=c(highData$meanEnd-1, highData$meanEnd)) +
	coord_polar(start = start_Value, theta="y") +
	scale_fill_manual(values=cbPalette) +
	ylim( c(highData$meanEnd-1, highData$meanEnd)) +
     xlim(c(0, 4)) +
     theme_bw() +
     theme(panel.grid=element_blank()) +
     theme(axis.text=element_blank()) +
     theme(axis.ticks=element_blank()) +
     labs(title="Customized ring plot")



geom_line(mapping = NULL, data = NULL, stat = "identity", position = "identity")

library(gridExtra)
png("wingbeatCorrected.png", height=4, width=8, units="in", res=1024, type = "cairo")
grid.arrange(p1, nrow=1)
dev.off()

### Code to plot a bar graph with error bars for an analysis
plot.DoubleEnded.BarGraph <- function(analysis, yLabel, yMin, yMax){
	#handle Error
	analysisMean <- c( analysis$coefficients[1],  analysis$coefficients[1] + analysis$coefficients[2])
	names(analysisMean) <- c('Prompted', 'Routine')
	coef(analysis)
	confint(analysis)
	sd = sqrt(diag(vcov(analysis)))
	analysisValues <- cbind("2.5 %"=-sd*1.96+coef(analysis),"97.5 %"=sd*1.96+coef(analysis))
	rownames(analysisValues )<- c('Prompted', 'Routine')
	analysisValues [2,] <- analysisValues [2,] + analysis$coefficients[1]
	mp <- barplot(analysisMean , ylim=c(yMin, yMax),
	col=c('red', 'blue'), main=c( "Flight Type vs", yLabel), xlab="Flight Type", ylab=yLabel)

	# Plot the vertical lines of the error bars
	# The vertical bars are plotted at the midpoints
	segments(mp,analysisValues [,1], mp, analysisValues [,2], lwd=2)
	# Now plot the horizontal bounds for the error bars
	# 1. The lower bar
	segments(mp - 0.1, analysisValues , mp + 0.1, analysisValues , lwd=2)
	# 2. The upper bar
	segments(mp - 0.1, analysisValues , mp + 0.1, analysisValues , lwd=2)
}


